## dietlibc 0.34~cvs20160606

=== Makefile ===
INSTALL=install
prefix?=/opt/diet
# Set the following to install to a different root
#DESTDIR=/tmp/fefix
# Use "make DEBUG=1" to compile a debug version.

LIBDIR=${prefix}/lib
BINDIR=${prefix}/bin
MAN1DIR=${prefix}/man/man1

EXTRACFLAGS=

MYARCH:=$(shell uname -m | sed -e 's/i[4-9]86/i386/' -e 's/armv[3-7]t\?e\?[lb]/arm/')

# This extra-ugly cruft is here so make will not run uname and sed each
# time it looks at $(OBJDIR).  This alone sped up running make when
# nothing has to be done from 1 sec to 0.12 sec on a 900 MHz Athlon.
# We don't use ARCH:=$(MYARCH) so we can detect unknown architectures.
ifeq ($(MYARCH),i386)
ARCH=i386
else
ifeq ($(MYARCH),mips)
ARCH=mips
else
ifeq ($(MYARCH),alpha)
ARCH=alpha
else
ifeq ($(MYARCH),ppc)
ARCH=ppc
else
ifeq ($(MYARCH),ppc64)
ARCH=ppc64
else
ifeq ($(MYARCH),ppc64le)
ARCH=ppc64le
else
ifeq ($(MYARCH),arm)
ARCH=arm
else
ifeq ($(MYARCH),aarch64)
ARCH=aarch64
else
ifeq ($(MYARCH),sparc)
ARCH=sparc
else
ifeq ($(MYARCH),sparc64)
ARCH=sparc64
else
ifeq ($(MYARCH),s390)
ARCH=s390
else
ifeq ($(MYARCH),s390x)
ARCH=s390x
else
ifeq ($(MYARCH),mipsel)
ARCH=mipsel
else
ifeq ($(MYARCH),mips64)
ARCH=mips64
else
ifeq ($(MYARCH),parisc)
ARCH=parisc
else
ifeq ($(MYARCH),parisc64)
ARCH=parisc
MYARCH=parisc
else
ifeq ($(MYARCH),x86_64)
ARCH=x86_64
else
ifeq ($(MYARCH),ia64)
ARCH=ia64
else
ifeq ($(MYARCH),armeb)
ARCH=arm
else
$(error unknown architecture, please fix Makefile)
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif

PIE=-fpie -fvisibility=hidden

# ARCH=$(MYARCH)

OBJDIR=bin-$(ARCH)
ILIBDIR=$(LIBDIR)-$(ARCH)

DIETHOME=$(shell pwd)

WHAT=	$(OBJDIR) $(OBJDIR)/start.o $(OBJDIR)/dyn_start.o $(OBJDIR)/dyn_stop.o \
	$(OBJDIR)/dietlibc.a $(OBJDIR)/liblatin1.a \
	$(OBJDIR)/libcompat.a $(OBJDIR)/libm.a \
	$(OBJDIR)/librpc.a $(OBJDIR)/libpthread.a \
	$(OBJDIR)/libcrypt.a \
	$(OBJDIR)/diet $(OBJDIR)/diet-i $(OBJDIR)/elftrunc \
	$(OBJDIR)/dnsd

all: $(WHAT)

profiling: $(OBJDIR)/libgmon.a $(OBJDIR)/pstart.o

DEFAULTCFLAGS=-pipe -nostdinc -D_REENTRANT $(EXTRACFLAGS)
CFLAGS=$(DEFAULTCFLAGS)
CROSS=

CC=gcc
CCC=$(CROSS)$(CC)
STRIP=$(COMMENT) $(CROSS)strip
INC=-I. -isystem include
#INC=-I. -Iinclude

VPATH=lib:libstdio:libugly:libcruft:libcrypt:libshell:liblatin1:libcompat:libdl:librpc:libregex:libm:profiling

SYSCALLOBJ=$(patsubst syscalls.s/%.S,$(OBJDIR)/%.o,$(sort $(wildcard syscalls.s/*.S)))

LIBOBJ=$(patsubst lib/%.c,$(OBJDIR)/%.o,$(sort $(wildcard lib/*.c)))
LIBUGLYOBJ=$(patsubst libugly/%.c,$(OBJDIR)/%.o,$(sort $(wildcard libugly/*.c)))
LIBSTDIOOBJ=$(patsubst libstdio/%.c,$(OBJDIR)/%.o,$(sort $(wildcard libstdio/*.c)))
LIBCRUFTOBJ=$(patsubst libcruft/%.c,$(OBJDIR)/%.o,$(sort $(wildcard libcruft/*.c)))
LIBCRYPTOBJ=$(patsubst libcrypt/%.c,$(OBJDIR)/%.o,$(sort $(wildcard libcrypt/*.c)))
LIBSHELLOBJ=$(patsubst libshell/%.c,$(OBJDIR)/%.o,$(sort $(wildcard libshell/*.c)))
LIBCOMPATOBJ=$(patsubst libcompat/%.c,$(OBJDIR)/%.o,$(sort $(wildcard libcompat/*.c))) $(OBJDIR)/syscall.o
LIBMATH=$(patsubst libm/%.c,%.o,$(sort $(wildcard libm/*.c)))

LIBRPCOBJ=$(patsubst librpc/%.c,$(OBJDIR)/%.o,$(sort $(wildcard librpc/*.c)))
LIBREGEXOBJ=$(patsubst libregex/%.c,$(OBJDIR)/%.o,$(sort $(wildcard libregex/*.c)))

LIBDLOBJ=$(patsubst libdl/%.c,$(OBJDIR)/%.o,$(sort $(wildcard libdl/*.c))) $(OBJDIR)/_dl_jump.o

LIBPTHREAD_OBJS=$(patsubst libpthread/%.c,$(OBJDIR)/%.o,$(sort $(shell ./threadsafe.sh))) $(OBJDIR)/__testandset.o

LIBGMON_OBJS=$(OBJDIR)/__mcount.o $(OBJDIR)/monitor.o $(OBJDIR)/profil.o

include $(ARCH)/Makefile.add

LIBMATHOBJ=$(patsubst %,$(OBJDIR)/%,$(LIBMATH))

ifeq ($(CFLAGS),$(DEFAULTCFLAGS))
CFLAGS+=-O -fomit-frame-pointer
endif

ifneq ($(DEBUG),)
CFLAGS = -g $(EXTRACFLAGS)
STRIP = :
endif
CFLAGS += -W -Wall -Wextra -Wchar-subscripts -Wmissing-prototypes -Wmissing-declarations -Wno-switch -Wno-unused -Wredundant-decls -Wshadow

ASM_CFLAGS = -Wa,--noexecstack
ifneq ($(subst clang,fnord,$(CC)),$(CC))
ASM_CFLAGS += -fno-integrated-as
endif

ifeq ($(ALWAYS_PIC),1)
CCFLAGS=$(CFLAGS) $(PIE)
else
CCFLAGS=$(CFLAGS)
endif

PWD=$(shell pwd)

.SUFFIXES:
.SUFFIXES: .S .c

# added real dynamic dietlibc.so
PICODIR = pic-$(ARCH)

$(OBJDIR) $(PICODIR):
	mkdir $@

% :: %,v

ifeq ($(CC),tcc)
$(OBJDIR)/%.o: %.S $(ARCH)/syscalls.h | $(OBJDIR)
	$(CROSS)cpp $(INC) $< | $(CROSS)as --noexecstack -o $@

$(OBJDIR)/%.o: %.c | $(OBJDIR)
	tcc -I. -Iinclude -c $< -o $@
	-$(STRIP) -x -R .comment -R .note $@
else
$(OBJDIR)/pstart.o: start.S | $(OBJDIR)
	$(CCC) $(INC) $(CCFLAGS) -DPROFILING -c $< $(ASM_CFLAGS) -o $@

$(OBJDIR)/%.o: %.S $(ARCH)/syscalls.h | $(OBJDIR)
	$(CCC) $(INC) $(CCFLAGS) $(EXTRACFLAGS) -c $< $(ASM_CFLAGS) -o $@

$(OBJDIR)/pthread_%.o: libpthread/pthread_%.c | $(OBJDIR)
	$(CCC) $(INC) $(CCFLAGS) $(EXTRACFLAGS) -c $< -o $@
	-$(STRIP) -x -R .comment -R .note $@

$(OBJDIR)/%.o: %.c | $(OBJDIR)
	$(CCC) $(INC) $(CCFLAGS) $(EXTRACFLAGS) -c $< -o $@ -D__dietlibc__
	-$(STRIP) -x -R .comment -R .note $@
endif



ifeq ($(shell $(CC) -v 2>&1 | grep "gcc version"),gcc version 4.0.0)
SAFE_CFLAGS=$(shell echo $(CCFLAGS)|sed 's/-Os/-O2/')
SAFER_CFLAGS=$(shell echo $(CCFLAGS)|sed 's/-Os/-O/')
else
SAFE_CFLAGS=$(CCFLAGS)
SAFER_CFLAGS=$(CCFLAGS)
endif

CC+=-D__dietlibc__

$(OBJDIR)/start-pie.o: start.S | $(OBJDIR)
	$(CCC) $(INC) $(CCFLAGS) $(EXTRACFLAGS) -c $< $(ASM_CFLAGS) -fpie -o $@

$(OBJDIR)/start.o: start.S | $(OBJDIR)
	$(CCC) $(INC) $(CCFLAGS) $(EXTRACFLAGS) -c $< $(ASM_CFLAGS) -fno-pie -o $@


$(OBJDIR)/crypt.o: libcrypt/crypt.c | $(OBJDIR)
	$(CCC) $(INC) $(SAFER_CFLAGS) -c $< -o $@

DIETLIBC_OBJ = $(OBJDIR)/unified.o \
$(SYSCALLOBJ) $(LIBOBJ) $(LIBSTDIOOBJ) $(LIBUGLYOBJ) \
$(LIBCRUFTOBJ) $(LIBCRYPTOBJ) $(LIBSHELLOBJ) $(LIBREGEXOBJ) \
$(OBJDIR)/__longjmp.o $(OBJDIR)/setjmp.o \
$(OBJDIR)/clone.o

$(OBJDIR)/dietlibc.a: $(DIETLIBC_OBJ) $(OBJDIR)/start.o
	$(CROSS)ar cru $@ $(DIETLIBC_OBJ)

$(OBJDIR)/librpc.a: $(LIBRPCOBJ)
	$(CROSS)ar cru $@ $(LIBRPCOBJ)

$(OBJDIR)/libcrypt.a: | $(OBJDIR)
	touch dummy.c
	$(CCC) -c dummy.c
	$(CROSS)ar cru $@ dummy.o
	rm -f dummy.c dummy.o

dummy.o:

LIBLATIN1_OBJS=$(patsubst liblatin1/%.c,$(OBJDIR)/%.o,$(sort $(wildcard liblatin1/*.c)))
$(OBJDIR)/liblatin1.a: $(LIBLATIN1_OBJS)
	$(CROSS)ar cru $@ $^

$(OBJDIR)/libgmon.a: $(LIBGMON_OBJS)
	$(CROSS)ar cru $@ $^

$(OBJDIR)/libpthread.a: $(LIBPTHREAD_OBJS) dietfeatures.h
	$(CROSS)ar cru $@ $(LIBPTHREAD_OBJS)

$(OBJDIR)/libcompat.a: $(LIBCOMPATOBJ)
	$(CROSS)ar cru $@ $(LIBCOMPATOBJ)

$(OBJDIR)/libm.a: $(LIBMATHOBJ)
	$(CROSS)ar cru $@ $(LIBMATHOBJ)

$(OBJDIR)/seekdir.o $(OBJDIR)/clnt_raw.o $(OBJDIR)/clnt_udp.o \
$(PICODIR)/seekdir.o $(PICODIR)/clnt_raw.o $(PICODIR)/clnt_udp.o \
$(OBJDIR)/sha256crypt.o $(OBJDIR)/sha512crypt.o \
$(PICODIR)/sha256crypt.o $(PICODIR)/sha512crypt.o: CFLAGS+=-fno-strict-aliasing

LD_UNSET = env -u LD_RUN_PATH

dyn: dyn_lib

# added dynamic linker
$(OBJDIR)/libdl.a: $(LIBDLOBJ)
	$(CROSS)ar cru $@ $(LIBDLOBJ)

dyn_lib: $(PICODIR) $(PICODIR)/libc.so $(PICODIR)/dstart.o \
	$(PICODIR)/dyn_so_start.o $(PICODIR)/dyn_start.o $(PICODIR)/dyn_stop.o \
	$(PICODIR)/libpthread.so $(PICODIR)/libdl.so $(PICODIR)/libcompat.so \
	$(PICODIR)/libm.so $(PICODIR)/diet-dyn $(PICODIR)/diet-dyn-i

$(PICODIR)/%.o: %.S $(ARCH)/syscalls.h | $(PICODIR)
	$(CCC) $(INC) $(CCFLAGS) $(EXTRACFLAGS) -fPIC -D__DYN_LIB $(ASM_CFLAGS) -c $< -o $@

$(PICODIR)/pthread_%.o: libpthread/pthread_%.c | $(PICODIR)
	$(CCC) $(INC) $(CCFLAGS) $(EXTRACFLAGS) -fPIC -D__DYN_LIB -c $< -o $@
	$(STRIP) -x -R .comment -R .note $@

$(PICODIR)/%.o: %.c | $(PICODIR)
	$(CCC) $(INC) $(CCFLAGS) $(EXTRACFLAGS) -fPIC -D__DYN_LIB -c $< -o $@
	$(STRIP) -x -R .comment -R .note $@

$(PICODIR)/dstart.o: start.S | $(PICODIR)
	$(CCC) $(INC) $(CCFLAGS) $(EXTRACFLAGS) -fPIC -D__DYN_LIB $(ASM_CFLAGS) -c $< -o $@

$(PICODIR)/dyn_so_start.o: dyn_start.c | $(PICODIR)
	$(CCC) $(INC) $(CCFLAGS) $(EXTRACFLAGS) -fPIC -D__DYN_LIB -D__DYN_LIB_SHARED -c $< -o $@
	$(STRIP) -x -R .comment -R .note $@

DYN_LIBC_PIC = $(LIBOBJ) $(LIBSTDIOOBJ) $(LIBUGLYOBJ) \
$(LIBCRUFTOBJ) $(LIBCRYPTOBJ) $(LIBSHELLOBJ) $(LIBREGEXOBJ)

DYN_LIBC_OBJ = $(PICODIR)/dyn_syscalls.o $(PICODIR)/errlist.o \
	$(patsubst $(OBJDIR)/%.o,$(PICODIR)/%.o,$(DYN_LIBC_PIC))

DYN_PTHREAD_OBJS = $(patsubst $(OBJDIR)/%.o,$(PICODIR)/%.o,$(LIBPTHREAD_OBJS))

DYN_LIBDL_OBJS = $(patsubst $(OBJDIR)/%.o,$(PICODIR)/%.o,$(LIBDLOBJ))

DYN_LIBCOMPAT_OBJS = $(patsubst $(OBJDIR)/%.o,$(PICODIR)/%.o,$(LIBCOMPATOBJ))

DYN_LIBMATH_OBJS = $(patsubst $(OBJDIR)/%.o,$(PICODIR)/%.o,$(LIBMATHOBJ))

$(PICODIR)/libc.so: $(PICODIR) $(DYN_LIBC_OBJ)
	$(LD_UNSET) $(CCC) -nostdlib -shared -o $@ $(CCFLAGS) -fPIC $(DYN_LIBC_OBJ) -lgcc -Wl,-soname=libc.so

$(PICODIR)/libpthread.so: $(DYN_PTHREAD_OBJS) dietfeatures.h $(PICODIR)/libc.so
	$(LD_UNSET) $(CCC) -nostdlib -shared -o $@ $(CCFLAGS) -fPIC $(DYN_PTHREAD_OBJS) -L$(PICODIR) -lc -Wl,-soname=libpthread.so

$(PICODIR)/libdl.so: libdl/_dl_main.c dietfeatures.h $(PICODIR)/libc.so
	$(LD_UNSET) $(CCC) -D__OD_CLEAN_ROOM -DNODIETREF -fPIC -nostdlib -shared -Bsymbolic -Wl,-Bsymbolic \
		-o $@ $(SAFE_CFLAGS) $(INC) libdl/_dl_main.c -Wl,-soname=libdl.so

$(OBJDIR)/pthread_create.o $(PICODIR)/pthread_create.o: dietfeatures.h
$(OBJDIR)/pthread_internal.o $(PICODIR)/pthread_internal.o: dietfeatures.h

#$(PICODIR)/libdl.so: $(DYN_LIBDL_OBJS) dietfeatures.h
#	$(CCC) -nostdlib -shared -o $@ $(CCFLAGS) -fPIC $(DYN_LIBDL_OBJS) -L$(PICODIR) -ldietc -Wl,-soname=libdl.so

$(PICODIR)/libcompat.so: $(DYN_LIBCOMPAT_OBJS) dietfeatures.h $(PICODIR)/libc.so
	$(LD_UNSET) $(CCC) -nostdlib -shared -o $@ $(CCFLAGS) -fPIC $(DYN_LIBCOMPAT_OBJS) -L$(PICODIR) -lc -Wl,-soname=libcompat.so

$(PICODIR)/libm.so: $(DYN_LIBMATH_OBJS) dietfeatures.h $(PICODIR)/libc.so
	$(LD_UNSET) $(CCC) -nostdlib -shared -o $@ $(CCFLAGS) -fPIC $(DYN_LIBMATH_OBJS) -L$(PICODIR) -lc -Wl,-soname=libm.so


$(SYSCALLOBJ): syscalls.h

$(OBJDIR)/elftrunc: $(OBJDIR)/diet contrib/elftrunc.c
	bin-$(MYARCH)/diet $(CCC) $(CFLAGS) -o $@ contrib/elftrunc.c

$(OBJDIR)/dnsd: $(OBJDIR)/diet contrib/dnsd.c
	bin-$(MYARCH)/diet $(CCC) $(CFLAGS) -o $@ contrib/dnsd.c

VERSION=dietlibc-$(shell head -n 1 CHANGES|sed 's/://')
CURNAME=$(notdir $(shell pwd))

$(OBJDIR)/diet: $(OBJDIR)/start.o $(OBJDIR)/dyn_start.o diet.c $(OBJDIR)/dietlibc.a $(OBJDIR)/dyn_stop.o
	$(CCC) -isystem include $(CFLAGS) -nostdlib -o $@ $^ -DDIETHOME=\"$(DIETHOME)\" -DVERSION=\"$(VERSION)\" -lgcc
	$(STRIP) -R .comment -R .note $@

$(OBJDIR)/diet-i: $(OBJDIR)/start.o $(OBJDIR)/dyn_start.o diet.c $(OBJDIR)/dietlibc.a $(OBJDIR)/dyn_stop.o
	$(CCC) -isystem include $(CFLAGS) -nostdlib -o $@ $^ -DDIETHOME=\"$(prefix)\" -DVERSION=\"$(VERSION)\" -DINSTALLVERSION -lgcc
	$(STRIP) -R .comment -R .note $@

$(PICODIR)/diet-dyn: $(PICODIR)/start.o $(PICODIR)/dyn_start.o diet.c
	$(LD_UNSET) $(CCC) -isystem include $(CFLAGS) -fPIC -nostdlib -o $@ $^ -DDIETHOME=\"$(DIETHOME)\" -D__DYN_LIB -DVERSION=\"$(VERSION)\" -L$(PICODIR) -lc -lgcc $(PICODIR)/dyn_stop.o -Wl,-dynamic-linker=$(DIETHOME)/$(PICODIR)/libdl.so
	$(STRIP) -R .command -R .note $@

$(PICODIR)/diet-dyn-i: $(PICODIR)/start.o $(PICODIR)/dyn_start.o diet.c
	$(LD_UNSET) $(CCC) -isystem include $(CFLAGS) -fPIC -nostdlib -o $@ $^ -DDIETHOME=\"$(prefix)\" -D__DYN_LIB -DVERSION=\"$(VERSION)\" -L$(PICODIR) -lc -lgcc $(PICODIR)/dyn_stop.o -Wl,-dynamic-linker=$(ILIBDIR)/libdl.so -DINSTALLVERSION
	$(STRIP) -R .command -R .note $@

$(OBJDIR)/djb: $(OBJDIR)/compile $(OBJDIR)/load

$(OBJDIR)/compile:
	echo 'exec' $(CC) '$(CCFLAGS) -I$(PWD)/$(OBJDIR)/include -c $${1+"$$@"}' > $@
	chmod 755 $@

$(OBJDIR)/load:
	echo 'main="$$1"; shift; exec' $(CC) '-nostdlib -o "$$main" $(PWD)/$(OBJDIR)/start.o "$$main".o $${1+"$$@"} $(PWD)/$(OBJDIR)/dietlibc.a -lgcc'  > $@
	chmod 755 $@

clean:
	rm -f *.o *.a t t1 compile load elftrunc exports mapfile libdietc.so include/errno_definition.h
	rm -rf bin-* pic-*
	$(MAKE) -C examples clean
	$(MAKE) -C dynlinker clean
	$(MAKE) -C libdl clean

tar: clean rename
	cd ..; tar cvvf $(VERSION).tar.bz2 --use=bzip2 --exclude CVS $(VERSION)

rename:

=== libdl/Makefile ===
# local "test" make file

CC  = $(CROSS)gcc
DCC = diet $(CC)

SRC = $(sort $(wildcard *.c)) # test/test.c
OBJ = _dl_jump.o $(SRC:.c=.o)

#CFLAGS = -Wall -D__OD_CLEAN_ROOM -DNODIETREF -fPIC -g -O
#CFLAGS = -Wall -O2 -Bsymbolic -D__OD_CLEAN_ROOM -DNODIETREF -fPIC -frerun-loop-opt -fschedule-insns2 $(DEB)
CFLAGS = -Wall -g -O -I.. -isystem ../include -Bsymbolic -D__OD_CLEAN_ROOM -DNODIETREF -fPIC -frerun-loop-opt -fschedule-insns2 $(DEB)
# -fomit-frame-pointer

%.o : %.S
	$(DCC) $(CFLAGS) -c -o $@ $^

%.o : %.c
	$(DCC) $(CFLAGS) -c -o $@ $^

it: t.out

a.out: t.out
	$(CROSS)gcc -O -g test/a.c t.out -L/opt/diet/lib-i386 -lc -lgcc -o $@ -Wl,-dynamic-linker=`pwd`/t.out -nostdlib

t.out: _dl_main.o
	$(CROSS)ld -shared -o $@ $? -soname=libdl.so -Bsymbolic

all: test.out libdl.a

libdl.a: $(OBJ)
	ar cru $@ $^

test.g: test/test.c
	gcc -o $@ $^ -ldl

test.out: $(OBJ) test/test.o
	diet gcc -o $@ $^

clean:
	$(RM) *.o *.a *.out *~ # *.so

=== libpthread/Makefile ===
all: libpthread.a

M=$(shell ../findcflags.sh $(CC))

ARCH=$(shell uname -m | sed 's/i[4-9]86/i386/')

CFLAGS= -g #-pipe -O -march=k6
CFLAGS= -pipe
CROSS=

CC=gcc

VPATH=../$(ARCH)/

PTHREAD_OBJS = __testandset.o $(patsubst %.c,%.o,$(sort $(wildcard pthread_*.c)))

TESTS = $(patsubst %.c,%,$(sort $(wildcard test-*.c)))

%.o : %.c
	$(CC) $(CFLAGS) -c -o $@ $?

#include ../$(ARCH)/Makefile.add

ifeq ($(CFLAGS),-pipe)
CFLAGS+= -O2 -fomit-frame-pointer
endif

CFLAGS += -W -Wall
#CFLAGS += -fPIC

CFLAGS += -I. -I.. -I../include -Wall


PWD=$(shell pwd)

.SUFFIXES:
.SUFFIXES: .S .c

.PHONY: clean tests test.out

% :: %,v

%.o: %.S
	$(CROSS)$(CC) -I. -Iinclude $(CFLAGS) -c $<

%.o: %.c
	$(CROSS)$(CC) -I. -Iinclude $(CFLAGS) -c $<
#	$(CROSS)strip -x -R .comment -R .note $@

libpthread.a: $(PTHREAD_OBJS)
	$(CROSS)ar cr $@ $^

libpthread.so: libpthread.a
	$(CROSS)ld -whole-archive -shared -o $@ $^


clean: tests-clean
	$(RM) *.o *.a *.so *.out *~ *.oa

exports: libpthread.a
	nm -g libpthread.a | grep -w T | awk '{ print $$3 }' | sort -u > exports

.PHONY: test.out

test.out: test.o libpthread.a $(LIBS)
	$(CROSS)$(CC) -g $(CFLAGS) -nostdlib ../bin-$(ARCH)/start.o ../bin-$(ARCH)/dyn_start.o -o $@ $^ ../bin-$(ARCH)/dietlibc.a -lgcc ../bin-$(ARCH)/dyn_stop.o

tests: tests-clean $(TESTS)

tests-clean:
	$(RM) $(TESTS)

# libpthread.a
pthread.oa: $(PTHREAD_OBJS)
	ld -r -o $@ $(patsubst pthread_errno.o,,$^)

$(TESTS): pthread.oa
	$(CROSS)$(CC) -g $(CFLAGS) -nostdlib ../bin-$(ARCH)/start.o ../bin-$(ARCH)/dyn_start.o -o $@ $@.c $^ ../bin-$(ARCH)/dietlibc.a -lgcc ../bin-$(ARCH)/dyn_stop.o

.PHONY: sparc ppc mips arm alpha i386

sparc ppc alpha i386:
	$(MAKE) ARCH=$@ CROSS=$@-linux- all t libdietc.so

mips arm:
	$(MAKE) ARCH=$@ CROSS=$@-linux- all t libdietc.so

=== test/Makefile ===
all: direnttest inettest stdiotests stdlibtests stringtests timetests \
test ffs getdelim stdlib 

DIET=diet
CC=gcc
CFLAGS=-nostdinc -Wall

LCOMPAT=-lcompat

TESTPROGRAMS=adjtime alarm argv asprintf atexit bsearch byteswap calloc confstr cycles empty fadvise flush fnmatch \
fputc ftw fwrite getaddrinfo getenv getgrnam gethostbyaddr gethostbyname \
gethostbyname_r getmntent getopt getpass getpwnam getservbyname getservbyport getusershell \
glob grent hasmntopt hello iconv if_nameindex ltostr malloc-debugger md5_testharness \
memccpy memcpy memchr memcmp memrchr memusage mktime mmap_test pipe printf printftest \
protoent prototypes putenv pwent rand48 read1 readdir regex select sendfile servent siglist \
speed spent sprintf sscanf stdarg strcasecmp strcmp strncat strncpy strptime strrchr \
strstr strtol sysenter ungetc utime waitpid

test: $(TESTPROGRAMS)

ffs: ffs.c
	$(DIET) $(CC) $(CFLAGS) $^ $(LCOMPAT) -o $@
	
getdelim: getdelim.c
	$(DIET) $(CC) $(CFLAGS) $^ $(LCOMPAT) -o $@ 

syscall: syscall.c
	$(DIET) $(CC) $^ -o $@

testandset: testandset.c
	$(DIET) $(CC) $^ -o $@ 

direnttest:
	 $(MAKE) -C dirent CC="$(CC)" CFLAGS="$(CFLAGS)" DIET=$(DIET) LCOMPAT=$(LCOMPAT)

inettest:
	$(MAKE) -C inet CC="$(CC)" CFLAGS="$(CFLAGS)" DIET=$(DIET) LCOMPAT=$(LCOMPAT)

stdiotests:
	$(MAKE) -C stdio CC="$(CC)" CFLAGS="$(CFLAGS)" DIET=$(DIET) LCOMPAT=$(LCOMPAT)

stdlibtests:
	$(MAKE) -C stdlib CC="$(CC)" CFLAGS="$(CFLAGS)" DIET=$(DIET) LCOMPAT=$(LCOMPAT)

stringtests:
	$(MAKE) -C string CC="$(CC)" CFLAGS="$(CFLAGS)" DIET=$(DIET) LCOMPAT=$(LCOMPAT)

timetests:
	$(MAKE) -C time CC="$(CC)" CFLAGS="$(CFLAGS)" DIET=$(DIET) LCOMPAT=$(LCOMPAT)
	
	
%: %.c
	$(DIET) $(CC) $(CFLAGS) $^ -o $@

clean:
	rm -f $(TESTPROGRAMS) getdelim ffs
	$(MAKE) -C dirent clean
	$(MAKE) -C stdio clean
	$(MAKE) -C stdlib clean
	$(MAKE) -C string clean
	$(MAKE) -C time clean

=== test/inet/Makefile ===
DIET=diet
CC=gcc
CFLAGS=-Wall

TESTPROGRAMS=test_ifindex tst-gethnm tst-ntoa
# tst-network does not link w diet libc
all: inet 
	
inet: $(TESTPROGRAMS)	

%: %.c
	$(DIET) $(CC) $(CFLAGS) $^ -o $@

clean:
	rm -f $(TESTPROGRAMS)

=== test/stdlib/Makefile ===
DIET=diet
CC=gcc

CFLAGS=-Wall -nostdinc

all: stdlibtest

TESTPROGRAMS=test-canon testdiv testrand testsort tst-calloc \
tst-environ tst-limits tst-malloc tst-rand48 tst-strtod tst-strtol \
tst-strtoll tst-system

stdlibtest: $(TESTPROGRAMS)
%: %.c
	$(DIET) $(CC) $(CFLAGS) $^ -o $@

clean:
	rm -f $(TESTPROGRAMS)

=== debian/changelog ===
dietlibc (0.34~cvs20160606-19) unstable; urgency=medium

  * fix FTBFS with GCC 15 by sticking to -std=gnu99 (Closes: #1096523)
  * bump Policy
  * apply lintian

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 26 Aug 2025 22:29:59 +0000

dietlibc (0.34~cvs20160606-18) unstable; urgency=medium

  [ Helge Deller ]
  * hppa brown paper bag fix

 -- Thorsten Glaser <tg@mirbsd.de>  Wed, 10 Jul 2024 02:50:42 +0200

dietlibc (0.34~cvs20160606-17) unstable; urgency=medium

  [ Helge Deller ]
  * make 5/6-args syscalls generally more reliable on hppa

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 09 Jul 2024 22:18:21 +0200

dietlibc (0.34~cvs20160606-16) unstable; urgency=medium

  [ Helge Deller ]
  * fix socketfns test crash in recvfrom()

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 08 Jul 2024 18:37:00 +0200

dietlibc (0.34~cvs20160606-15) unstable; urgency=medium

  * upload to unstable reverting GCC 14 test B-D
  * d/copyright: complete licence review, entirely new
    (cf. #1067946)
  * update description and patch headers
  * un-mark fadvise test as expect-fail on ARM (works now)
  * mark socketfns test as expect-fail on parisc (hppa),
    as qemu-user needs to be updated to match changed Linux kernel

 -- Thorsten Glaser <tg@mirbsd.de>  Sat, 06 Jul 2024 17:28:41 +0200

dietlibc (0.34~cvs20160606-14exp1) experimental; urgency=high

  [ Debian Janitor, lintian-brush ]
  * fix d/copyright, d/watch, Homepage, UMEGAYA and d/changelog
  * bump debhelper and S-V

  [ Bastian Germann ]
  * d/watch: Scan for other compression formats

  [ Helge Deller ]
  * Update hppa defs (Closes: #974690) (Closes: #1030998)

  [ Thorsten Glaser ]
  * avoid rmdir failing with ENOENT
  * add -ffreestanding to libc builds (Closes: #1069365)
  * test swp instruction for armel builds (Closes: #1017537)
  * B-D on GCC 14 and fix FTBFS with it (Closes: #1074910)
    uploading to experimental for that
  * Unbreak building on architectures with LFS/t64 in dpkg-buildflags
  * More fixing of the stack protector, pthreads, etc.
  * Apply lintian fixes

 -- Thorsten Glaser <tg@mirbsd.de>  Fri, 05 Jul 2024 00:20:35 +0200

dietlibc (0.34~cvs20160606-14) unstable; urgency=low

  * Ask dpkg-buildflags to keep LTO disabled. (Closes: #1015386)

 -- Thorsten Glaser <tg@mirbsd.de>  Tue, 19 Jul 2022 19:07:37 +0200

dietlibc (0.34~cvs20160606-12) unstable; urgency=low

  [ John David Anglin ]
  * Fix FTBFS due to bad syscall argument layout (Closes: #944489)

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 10 Nov 2019 21:44:57 +0100

dietlibc (0.34~cvs20160606-11) unstable; urgency=low

  * d/patches/bugfixes/cflags.diff: retain main CFLAGS on amd64, x32
    which adds missing EXTRACFLAGS on x32 (Closes: #943429)
  * Bump Policy; slightly update packaging
  * Update lintian overrides
  * d/patches/bugfixes/x32-struct-member-sizes.diff: Correct some
    struct member sizes, partially spotted by Bernhard Übelacker,
    fix smashed stack from undersized buffer (Closes: #925359)
  * idem: fix useconds_t not being unsigned while here

 -- Thorsten Glaser <tg@mirbsd.de>  Thu, 24 Oct 2019 21:47:00 +0200

dietlibc (0.34~cvs20160606-10) unstable; urgency=high

  * Back out “add latest syscalls” backport: the .s files and most
    arches are not yet capable of handling 5-/6-argument syscalls

 -- Thorsten Glaser <tg@mirbsd.de>  Mon, 08 Oct 2018 22:29:45 +0200

dietlibc (0.34~cvs20160606-9) unstable; urgency=high

  [ Larry Doolittle ]
  * Fix rare utime test failure

  [ Thorsten Glaser ]
  * Policy 4.2.1.1
    - Handle “terse” build option
    - I *think* we can R³=no
  * Backport some things from upstream
    - fix for FTBFS on IA64
    - some bounds and null/uninitialised plus warning fixes
    - add latest syscalls
  * Plug stack overflow in regex engine (FTBFS on alpha)
  * Fix weak symbols (FTBFS) on IA64
  * Hook up ppoll (needed for socketcall Debian patch) on IA64
  * Fix pthread SIGBUS (during atomic operations) on several
    architectures by making _pthread_fastlock.__spinlock and
    pthread_once_t “long”s (changes ABI but we’re static-only)
  * Fix pasto in UMEGAYA metadata

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 07 Oct 2018 00:19:36 +0200

dietlibc (0.34~cvs20160606-8) unstable; urgency=medium

  [ Thorsten Glaser ]
  * Fix typo in <stddef.h> causing warning on offsetof() uses.
  * Refresh all patches.
  * Update VCS-* URIs for Salsa.
  * Fix build log scanner warnings.
  * Address lintian concerns.

  [ Larry Doolittle ]
  * Fix applications using newer Linux headers. (Closes: #883534)
  * Hook up the unshare() syscall.

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 01 Jul 2018 20:32:34 +0200

dietlibc (0.34~cvs20160606-7) unstable; urgency=medium

  * Make builds reproducible on ARM by working around ld.bfd issue.

 -- Christian Seiler <christian@iwakd.de>  Mon, 03 Jul 2017 06:32:54 +0200

dietlibc (0.34~cvs20160606-6) unstable; urgency=medium

  [ Héctor Orón Martínez ]
  * debian/control: drop myself from maintainers field.

  [ Christian Seiler ]
  * arm64: fix accidental register reuse in __testandset (Closes: #851379)
  * Add Thorsten Glaser to Uploaders.

 -- Christian Seiler <christian@iwakd.de>  Sat, 18 Feb 2017 12:10:09 +0100

dietlibc (0.34~cvs20160606-5) unstable; urgency=medium

  * hppa: fix pthread_atfork() and getsockopt() FTBFS bugs
  * alpha: fix FTBFS due to same TCB / TP issue
  * alpha: fix __testandset return value
  * alpha: fix setjmp() (previously completely broken)
  * Unit tests: mark tst-calloc as expected failure on arm64 for now.
    This build failure is not a regression: the test was enabled only in
    the latest version, and would have failed im previous versions as well.

 -- Christian Seiler <christian@iwakd.de>  Wed, 25 Jan 2017 22:25:27 +0100

dietlibc (0.34~cvs20160606-4) unstable; urgency=medium

  * Also run unittests linked against -lpthread.
  * Only show unit test error output at the very end.
  * Don't override errno_location in libpthread if TLS is enabled.
    (Closes: #850276)


=== debian/control ===
Source: dietlibc
Section: devel
Priority: optional
Homepage: https://www.fefe.de/dietlibc/
Maintainer: Christian Seiler <christian@iwakd.de>
Uploaders: Thorsten Glaser <tg@mirbsd.de>
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13), dh-exec
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/dietlibc.git
Vcs-Browser: https://salsa.debian.org/debian/dietlibc

Package: dietlibc-dev
Section: libdevel
Architecture: alpha amd64 arm arm64 armeb armel armhf hppa i386 ia64 mips mipsel mips64el powerpc powerpcspe ppc64 ppc64el s390 s390x sparc sparc64 x32
Depends: ${misc:Depends}
Multi-Arch: same
Suggests: dietlibc-doc
Description: diet libc - a libc optimized for small size
 The diet libc is a C library that is optimized for small size. It
 can be used to create small statically linked binaries for Linux
 on alpha, ARM, hppa (PA-RISC), IA-64, MIPS, PowerPC, S/390, SPARC
 and x86 under GPLv2.
 .
 This package is used to compile programs with the diet libc.
 .
 The diet libc also supports dynamic linking, but this has been
 temporarily disabled because of problems with it.

Package: dietlibc-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: dietlibc-dev
Description: diet libc documentation - a libc optimized for small size
 The diet libc is a C library that is optimized for small size. It
 can be used to create small statically linked binaries for Linux
 on alpha, ARM, hppa (PA-RISC), IA-64, MIPS, PowerPC, S/390, SPARC
 and x86 under GPLv2.
 .
 This package contains the documentation for the diet libc.

=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(filter terse,${DEB_BUILD_OPTIONS}))
export DH_VERBOSE=1
export V=1
export VERBOSE=1
endif

LC_ALL:=C.UTF-8
export LC_ALL

# dietlibc is static, where PIE is currently unsupported
# GCC LTO is broken anyway and extremely unappropriate for dietlibc anyway
# abi=+time64 is glibc-specific; LFS is handled internally
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie optimize=-lto abi=-lfs,-time64
export DEB_CFLAGS_MAINT_APPEND=-Wall -fno-pie
export DEB_LDFLAGS_MAINT_APPEND=-no-pie

# for "debian/rules get-orig-source"
ORIGTGZ_DATE:=          '2016-06-06 15:30Z'
ORIGTGZ_SOURCE:=	-D${ORIGTGZ_DATE}
ORIGTGZ_DESTINATION:=	0.34~cvs20160606

# determine whether we are cross-compiling
DEB_BUILD_GNU_TYPE?=$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE?=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
ifeq (${DEB_BUILD_GNU_TYPE},${DEB_HOST_GNU_TYPE})
CROSS:=0
else
CROSS:=1
endif

EXTRA_MAKE_FLAGS =

TRIPLET?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEBIANARCH?=$(shell dpkg-architecture -qDEB_HOST_ARCH)

ARCH=$(DEBIANARCH)
ifeq ($(ARCH),amd64)
  ARCH=x86_64
else
ifeq ($(ARCH),powerpc)
  ARCH=ppc
else
ifeq ($(ARCH),powerpcspe)
  ARCH=ppc
  EXTRA_MAKE_FLAGS+=SOFTFPU=1
else
ifeq ($(ARCH),ppc64el)
  ARCH=ppc64le
else
ifeq ($(ARCH),mips64el)
  ARCH=mips64
else
ifeq ($(ARCH),hppa)
  ARCH=parisc
else
ifeq ($(ARCH),arm64)
  ARCH=aarch64
else
ifneq (,$(findstring arm,$(ARCH)))
  ARCH=arm
endif
endif
endif
endif
endif
endif
endif
endif

VERSION=$(shell head -n1 debian/changelog | sed --posix -e 's/.*(\(.*\)).*/\1/')
# Make this a recursively expanded variable, because we only want to
# evaluate it in the very last moment. Also, unset MAKELEVEL/MAKEFLAGS
# because this is not really a recursive make we want here.
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
  DIETLIBC_CFLAGS=$(shell env -u MAKELEVEL -u MAKEFLAGS -- make --silent -f debian/find_orig_cflags.mk print_orig_dietlibc_cflags MYARCH='$(ARCH)' DEBUG=1)
else
  DIETLIBC_CFLAGS=$(shell env -u MAKELEVEL -u MAKEFLAGS -- make --silent -f debian/find_orig_cflags.mk print_orig_dietlibc_cflags MYARCH='$(ARCH)')
endif
# dietlibc doesn’t care about CPPFLAGS/LDFLAGS, so add them to CFLAGS
DEBIAN_CFLAGS=$(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get LDFLAGS)
# GCC 15 defaults to C23, which this isn’t ready for
DEBIAN_CFLAGS+= -std=gnu99

%:
	dh $@

override_dh_auto_configure:
override_dh_auto_build-indep:
override_dh_auto_build-arch:
ifeq (0armel,${CROSS}${DEBIANARCH})
	# cf. Debian bug #1017537
	if gcc -O2 -Wall -Wextra -Wformat -Wno-unused debian/armel-swp.c && \
	    ./a.out && rm -f a.out; then \
		echo armel SWP instruction ok; \
	else \
		echo armel SWP instruction FAIL; \
		cat /proc/sys/abi/swp; \
		ls -l /proc/sys/abi/swp; \
		exit 1; \
	fi
endif
	# cf. Debian bug #523086
	test '!' -f parisc/strstr.S || \
	    mv -f parisc/strstr.S parisc/strstr.S.disabled
	# cf. Debian bug #944489
	test '!' -f parisc/setsockopt.S || \
	    mv -f parisc/setsockopt.S parisc/setsockopt.S.disabled
	#
	dh_auto_build -- prefix=/usr/lib/$(TRIPLET)/diet \
		MYARCH='$(ARCH)' VERSION='$(VERSION)' DEBUG=1 \
		$(EXTRA_MAKE_FLAGS) \
		CFLAGS='$(DEBIAN_CFLAGS) $(DIETLIBC_CFLAGS)'

override_dh_auto_test-indep:
override_dh_auto_test-arch:
ifeq (,$(filter nocheck,${DEB_BUILD_OPTIONS}))
ifeq (${CROSS},0)
	debian/unittests/suite.sh '$(ARCH)'
endif
endif

override_dh_auto_clean-indep:
override_dh_auto_clean-arch:
	dh_auto_clean -- MYARCH='$(ARCH)'
	rm -f debian/dietlibc-dev.postinst debian/dietlibc-dev.prerm
	# cf. Debian bug #523086
	test '!' -f parisc/strstr.S.disabled || \
	    mv -f parisc/strstr.S.disabled parisc/strstr.S
	# cf. Debian bug #944489
	test '!' -f parisc/setsockopt.S.disabled || \
	    mv -f parisc/setsockopt.S.disabled parisc/setsockopt.S
	#

override_dh_auto_install-indep:
override_dh_auto_install-arch:
	mkdir -p debian/tmp/etc
	dh_auto_install --max-parallel=1 -- prefix=/usr/lib/$(TRIPLET)/diet MYARCH='$(ARCH)' VERSION='$(VERSION)' DEBUG=1 \
		CFLAGS='$(DEBIAN_CFLAGS) $(DIETLIBC_CFLAGS)'
	sed -e 's/|ARCH|/$(ARCH)/g;s/|TRIPLET|/$(TRIPLET)/g;s/|DEBIANARCH|/$(DEBIANARCH)/g' <debian/dietlibc-dev.postinst.in \
	  >debian/dietlibc-dev.postinst
	sed -e 's/|ARCH|/$(ARCH)/g;s/|TRIPLET|/$(TRIPLET)/g;s/|DEBIANARCH|/$(DEBIANARCH)/g' <debian/dietlibc-dev.prerm.in \
	  >debian/dietlibc-dev.prerm
	chmod -x debian/*/usr/lib/$(TRIPLET)/diet/lib*/*.o

_ANONCVSROOT:=		:pserver:cvs@cvs.fefe.de:/cvs
_CVSEXPORT:=		env CVS_RSH=ssh TZ=UTC cvs -qd ${_ANONCVSROOT} -z9 export
_RESET_TIMES:=          find dietlibc-${ORIGTGZ_DESTINATION} -type f | xargs touch -d${ORIGTGZ_DATE}
_PACK:=			find dietlibc-${ORIGTGZ_DESTINATION} -type f | LC_ALL=C.UTF-8 sort | \
			    paxcpio -oC512 -Hustar -Mdist
get-orig-source:
	rm -rf $@.tmp
	mkdir $@.tmp
	# to get a Debian .orig.tar.gz we need to pull the source from CVS
	cd $@.tmp; ${_CVSEXPORT} ${ORIGTGZ_SOURCE} dietlibc
	# fixup files with CR-LF line endings
	cd $@.tmp; find dietlibc -type f -print0 | \
	    xargs -0 perl -pi -e 's/\r$$//' --
	# then rename and pack it up
	mv $@.tmp/dietlibc $@.tmp/dietlibc-${ORIGTGZ_DESTINATION}
	cd $@.tmp; ${_RESET_TIMES}
	cd $@.tmp; ${_PACK} | xz -7e >../dietlibc_${ORIGTGZ_DESTINATION}.orig.tar.xz
	rm -rf $@.tmp
	# there we are...
	ls -l dietlibc_${ORIGTGZ_DESTINATION}.orig.tar.xz

=== debian/tests/control ===
Tests: hello
Depends: dietlibc-dev, build-essential

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ https://www.fefe.de/dietlibc/ dietlibc-([0-9.]*)@ARCHIVE_EXT@
